// AtlCon1.h : Declaration of the CAtlCon

#include "resource.h"       // main symbols
#include <oledlg.h>

/////////////////////////////////////////////////////////////////////////////
// CAtlCon
class CAtlCon : 
	public CComObjectRoot,
	public CComCoClass<CAtlCon, &CLSID_CAtlCon>,
	public CWindowImpl<CAtlCon>,
	public IAtlCon,
	public IOleClientSite,
	public IOleInPlaceSite
{
public:
	CAtlCon()
	{
		m_bInPlaceActive = FALSE;
	}

DECLARE_REGISTRY_RESOURCEID(IDR_AtlCon)

BEGIN_COM_MAP(CAtlCon)
	COM_INTERFACE_ENTRY(IAtlCon)
	COM_INTERFACE_ENTRY(IOleClientSite)
	COM_INTERFACE_ENTRY(IOleWindow)
	COM_INTERFACE_ENTRY(IOleInPlaceSite)
END_COM_MAP()

BEGIN_MSG_MAP(CAtlCon)
	MESSAGE_HANDLER(WM_NCDESTROY, OnNCDestroy)
	COMMAND_ID_HANDLER(ID_FILE_OPEN, OnFileOpen)
	MESSAGE_HANDLER(WM_SIZE, OnSize)
	MESSAGE_HANDLER(WM_ERASEBKGND, OnErase)
END_MSG_MAP()

	LRESULT OnNCDestroy(UINT /* uMsg */, WPARAM /* wParam */, LPARAM /* lParam */, BOOL& /* lResult */)
	{
		Stop();
		return 0;
	}

	LRESULT OnErase(UINT /* uMsg */, WPARAM /* wParam */, LPARAM /* lParam */, BOOL& bHandled)
	{
		if (m_bInPlaceActive)
			return 0;
		bHandled = FALSE;
		return 1;
	}

	LRESULT OnSize(UINT /* uMsg */, WPARAM /* wParam */, LPARAM /* lParam */, BOOL& /* lResult */)
	{
		if (m_pOleObject && m_bInPlaceActive)
		{
			CComQIPtr<IOleInPlaceObject, &IID_IOleInPlaceObject> pInPlaceObject(m_pOleObject);
			RECT rcClient;
			GetClientRect(&rcClient);
			pInPlaceObject->SetObjectRects(&rcClient, &rcClient);
		}
		return 0;
	}

	LRESULT OnFileOpen(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		OLEUIINSERTOBJECT	io;
		TCHAR				szFile[_MAX_PATH];
		
		ZeroMemory(&io, sizeof(io));
		io.cbStruct = sizeof(io);
		szFile[0] = 0;
		io.lpszFile = szFile;
		io.cchFile  = _MAX_PATH;
		io.dwFlags  = IOF_DISABLELINK | IOF_DISABLEDISPLAYASICON | IOF_SHOWINSERTCONTROL | IOF_SELECTCREATECONTROL;
		
		if (OleUIInsertObject(&io) == OLEUI_OK)
		{
			if (io.dwFlags & IOF_CREATELINKOBJECT)
				MessageBox(_T("Sorry. Creation from a file is not currently supported."));
			else
			{
				if (m_pOleObject)
				{
					m_pOleObject->Close(OLECLOSE_NOSAVE);
					m_pOleObject.Release();
				}
				m_bInPlaceActive = FALSE;
				CoCreateInstance(io.clsid, NULL, CLSCTX_INPROC, IID_IOleObject, (void**)&m_pOleObject);
				if (!m_pOleObject)
				{
					MessageBox(_T("CoCreateInstance failed"));
					return 0;
				}
				m_pOleObject->SetClientSite(this);
				MSG msg;
				RECT rcPos;
				GetClientRect(&rcPos);
				m_pOleObject->DoVerb(OLEIVERB_INPLACEACTIVATE, &msg, this, 0, m_hWnd, &rcPos);
				MessageBox(_T("Created"),_T("Success"));
			}
		}
		return 0;
	}

// IAtlCon
public:
	STDMETHOD(Run)()
	{
		RECT rcPos = { CW_USEDEFAULT, 0, 0, 0 };
		HMENU hMenu = LoadMenu(_Module.GetResourceInstance(), MAKEINTRESOURCE(IDR_MENU1));
		Create(GetDesktopWindow(), rcPos, _T("ATL Container"), WS_VISIBLE | WS_OVERLAPPEDWINDOW, 0, (UINT)hMenu);
		ShowWindow(SW_SHOWNORMAL);
		return S_OK;
	}
	STDMETHOD(Stop)()
	{
		PostQuitMessage(0);
		return S_OK;
	}

// IOleClientSite
public:
    STDMETHOD(SaveObject)(void)
	{
		ATLTRACENOTIMPL(_T("IOleClientSite::SaveObject"));
	}
    STDMETHOD(GetMoniker)(DWORD dwAssign, DWORD dwWhichMoniker, IMoniker **ppmk)
	{
		ATLTRACENOTIMPL(_T("IOleClientSite::GetMoniker"));
	}
    STDMETHOD(GetContainer)(IOleContainer **ppContainer)
	{
		ATLTRACENOTIMPL(_T("IOleClientSite::GetContainer"));
	}
    STDMETHOD(ShowObject)(void)
	{
		ATLTRACENOTIMPL(_T("IOleClientSite::ShowObject"));
	}
    STDMETHOD(OnShowWindow)(BOOL fShow)
	{
		ATLTRACENOTIMPL(_T("IOleClientSite::OnShowWindow"));
	}
    STDMETHOD(RequestNewObjectLayout)(void)
	{
		ATLTRACENOTIMPL(_T("IOleClientSite::RequestNewObjectLayout"));
	}


// IOleWindow
public:
    STDMETHOD(GetWindow)(HWND *phwnd)
	{
		*phwnd = m_hWnd;
		return S_OK;
	}
    STDMETHOD(ContextSensitiveHelp)(BOOL fEnterMode)
	{
		ATLTRACENOTIMPL(_T("IOleWindow::CanInPlaceActivate"));
	}

// IOleInPlaceSite
public:
    STDMETHOD(CanInPlaceActivate)(void)
	{
		return S_OK;
	}
    STDMETHOD(OnInPlaceActivate)(void)
	{
		m_bInPlaceActive = TRUE;
		return S_OK;
	}
    STDMETHOD(OnUIActivate)(void)
	{
		ATLTRACENOTIMPL(_T("IOleInPlaceSite::OnUIActivate"));
	}
    STDMETHOD(GetWindowContext)(IOleInPlaceFrame **ppFrame, IOleInPlaceUIWindow **ppDoc,
		LPRECT lprcPosRect, LPRECT lprcClipRect, LPOLEINPLACEFRAMEINFO lpFrameInfo)
	{
		GetClientRect(lprcPosRect);
		GetClientRect(lprcClipRect);
		return S_OK;
	}
    STDMETHOD(Scroll)(SIZE scrollExtant)
	{
		ATLTRACENOTIMPL(_T("IOleInPlaceSite::Scroll"));
	}
    STDMETHOD(OnUIDeactivate)(BOOL fUndoable)
	{
		ATLTRACENOTIMPL(_T("IOleInPlaceSite::OnUIDeactivate"));
	}
    STDMETHOD(OnInPlaceDeactivate)( void)
	{
		m_bInPlaceActive = FALSE;
		return S_OK;
	}
    STDMETHOD(DiscardUndoState)( void)
	{
		ATLTRACENOTIMPL(_T("IOleInPlaceSite::DiscardUndoState"));
	}
    STDMETHOD(DeactivateAndUndo)( void)
	{
		ATLTRACENOTIMPL(_T("IOleInPlaceSite::DeactivateAndUndo"));
	}
    STDMETHOD(OnPosRectChange)(LPCRECT lprcPosRect)
	{
		ATLTRACENOTIMPL(_T("IOleInPlaceSite::OnPosRectChange"));
	}

	CComPtr<IOleObject> m_pOleObject;
	BOOL m_bInPlaceActive;
};
