// CircCtl.h : Declaration of the CCircCtl

#include "resource.h"       // main symbols
#include "CPEvent.h"		// connection point for events
#include <atlctl.h>
#include <olectl.h>

extern const GUID CLSID_CCircProps;

#define PRINTSIZE(theClass) \
{\
	TCHAR szBuf[255];\
	wsprintf(szBuf, _T("sizeof(") _T(#theClass) _T(") = %d\n"), sizeof(theClass));\
	OutputDebugString(szBuf);\
}

class CCircCtl :
	public CComObjectRoot,
	public CComCoClass<CCircCtl,&CLSID_CCircCtl>,
	public CComControl<CCircCtl>,
	public CStockPropImpl<CCircCtl, ICircCtl, &IID_ICircCtl, &LIBID_CIRCLib>,
	public IPersistStreamInitImpl<CCircCtl>,
	public IPersistStorageImpl<CCircCtl>,
	public IQuickActivateImpl<CCircCtl>,
	public IProvideClassInfo2Impl<&CLSID_CCircCtl, &DIID__CircEvents, &LIBID_CIRCLib>,
	public IOleControlImpl<CCircCtl>,
	public IOleObjectImpl<CCircCtl>,
	public IOleInPlaceActiveObjectImpl<CCircCtl>,
	public IViewObjectExImpl<CCircCtl>,
	public IOleInPlaceObjectWindowlessImpl<CCircCtl>,
	public IConnectionPointContainerImpl<CCircCtl>,
	public CProxy_CircEvents<CCircCtl>,
	public IDataObjectImpl<CCircCtl>,
	public ISpecifyPropertyPagesImpl<CCircCtl>,
	public IPropertyNotifySinkCP<CCircCtl, CComDynamicUnkArray >,
	public IPersistPropertyBagImpl<CCircCtl>,
	public IPerPropertyBrowsingImpl<CCircCtl>,
	public IOleLinkImpl<CCircCtl>,
	public IRunnableObjectImpl<CCircCtl>

{
public:
	CCircCtl()
	{
		m_bstrCaption = _T("ATL 2.0 Lives");
		m_bRequiresSave = TRUE;
		m_hPalette = NULL;
		m_hWnd = NULL;
		m_clrForeColor = RGB(255, 0, 0);
		m_clrBackColor = RGB(0, 0, 255);
	}
	~CCircCtl()
	{
		ATLTRACE(_T("I'm out of here\n"));
	}

	static LPCTSTR GetWindowClassName() {return _T("CCircCtl");}
//DECLARE_NOT_AGGREGATABLE(CCircCtl) 
DECLARE_REGISTRY_RESOURCEID(IDR_CircCtl)
DECLARE_GET_CONTROLLING_UNKNOWN()

BEGIN_COM_MAP(CCircCtl) 
	COM_INTERFACE_ENTRY(ICircCtl)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY_IMPL_IID(IID_IViewObject, IViewObjectEx)
	COM_INTERFACE_ENTRY_IMPL_IID(IID_IViewObject2, IViewObjectEx)
	COM_INTERFACE_ENTRY_IMPL(IViewObjectEx)
	COM_INTERFACE_ENTRY_IMPL(IDataObject)
	COM_INTERFACE_ENTRY_IMPL_IID(IID_IOleWindow, IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY_IMPL_IID(IID_IOleInPlaceObject, IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY_IMPL(IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY_IMPL(IOleInPlaceActiveObject)
	COM_INTERFACE_ENTRY_IMPL(IOleControl)
	COM_INTERFACE_ENTRY_IMPL(IOleObject)
	COM_INTERFACE_ENTRY_IMPL(IQuickActivate)
	COM_INTERFACE_ENTRY_IMPL(IPersistStorage)
	COM_INTERFACE_ENTRY_IMPL(IPersistStreamInit)
	COM_INTERFACE_ENTRY_IMPL(ISpecifyPropertyPages)
	COM_INTERFACE_ENTRY_IMPL(IPersistPropertyBag)
	COM_INTERFACE_ENTRY_IMPL(IPerPropertyBrowsing)
	COM_INTERFACE_ENTRY_IMPL(IOleLink)
	COM_INTERFACE_ENTRY_IMPL(IRunnableObject)
	COM_INTERFACE_ENTRY(IProvideClassInfo)
	COM_INTERFACE_ENTRY(IProvideClassInfo2)
	COM_INTERFACE_ENTRY_IMPL_IID(IID_IPersist, IPersistPropertyBag)
	COM_INTERFACE_ENTRY_IMPL(IConnectionPointContainer)
//	COM_INTERFACE_ENTRY(ISupportErrorInfo)
//	COM_INTERFACE_ENTRY_IMPL(IPointerInactive)
END_COM_MAP()

BEGIN_CONNECTION_POINT_MAP(CCircCtl)
	CONNECTION_POINT_ENTRY(IID_IPropertyNotifySink)
	CONNECTION_POINT_ENTRY(DIID__CircEvents)
END_CONNECTION_POINT_MAP()

BEGIN_MSG_MAP(CCircCtl)
	MESSAGE_HANDLER(WM_PAINT, OnPaint)
	MESSAGE_HANDLER(WM_CHAR, OnChar)
	MESSAGE_HANDLER(WM_LBUTTONDOWN, OnLButtonDown)
END_MSG_MAP()

BEGIN_PROPERTY_MAP(CCircCtl)
	PROP_ENTRY("Caption", DISPID_CAPTION, CLSID_CCircProps)
	PROP_ENTRY("Enabled", DISPID_ENABLED, CLSID_CCircProps)
	PROP_ENTRY("Fore Color", DISPID_FORECOLOR, CLSID_StockColorPage)
	PROP_ENTRY("Back Color", DISPID_BACKCOLOR, CLSID_StockColorPage)
	PROP_ENTRY("Font", DISPID_FONT, CLSID_StockFontPage)
END_PROPERTY_MAP()

// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);
// Implementation
public:
	HRESULT OnDraw(ATL_DRAWINFO& di);

	LRESULT OnChar(UINT, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		KeyPress(wParam);
		return 0;
	}
	STDMETHOD(DoVerb)(LONG iVerb,LPMSG lpmsg, IOleClientSite *pActiveSite,
				   LONG lindex,	HWND hwndParent, LPCRECT lprcPosRect)
	{
		if (iVerb == 1)
			return IOleObjectImpl<CCircCtl>::DoVerb(OLEIVERB_PROPERTIES, lpmsg, pActiveSite,
												lindex,	hwndParent, lprcPosRect);
		if (iVerb == 2)
			return IOleObjectImpl<CCircCtl>::DoVerb(OLEIVERB_SHOW, lpmsg, pActiveSite,
												lindex,	hwndParent, lprcPosRect);

		return IOleObjectImpl<CCircCtl>::DoVerb(iVerb, lpmsg, pActiveSite,
												lindex,	hwndParent, lprcPosRect);

	}
	LRESULT OnLButtonDown(UINT, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		Click();
		MessageBeep(MB_OK);
//		FireDataChange();
		return 0;
	}
	LRESULT OnCreate(UINT, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		// Won't be in here unless window based and active
		RECT rc;
		::GetClientRect(m_hWnd, &rc);
		HRGN hRgn = ::CreateEllipticRgn(rc.left, rc.top, rc.right + 1, rc.bottom + 1);
		::SetWindowRgn(m_hWnd, hRgn, FALSE);
		return 0;
	}
	STDMETHOD(QuickActivate)(QACONTAINER *pqacontainer, QACONTROL *pqacontrol)
	{
		m_hPalette = pqacontainer->hpal;
		return IQuickActivateImpl<CCircCtl>::QuickActivate(pqacontainer, pqacontrol);
	}

public:
	BOOL m_bEnabled;
	HPALETTE m_hPalette;
	CComBSTR m_bstrCaption;
	OLE_COLOR m_clrBackColor;
	OLE_COLOR m_clrForeColor;
	CComPtr<IFontDisp> m_pFont;
};

